/**********************************************************************
*  Name    : Fonctions gnrales                                      *
*  Author  : Nunes Dos Anjos Carlos                                   *
*  Notice  : Copyright (c) 2005 Nunes                                 *
*          : All Rights Reserved                                      *
*  Date    : 20/02/2013                                               *
*  Version : 1.0                                                      *
*  Notes   : pour le programme main                                   *
*          :                                                          *
**********************************************************************/


/** Convertisseur analogique numrique ******************************/
void ADC_Init(void)
{ // initialize the Analog-To-Digital converter.
    // First, we need to make sure the AN0 pin is enabled as an analog input
    // as the demo board potentiometer is connected to RA0/AN0
 	ANSELAbits.ANSA0 = 1;	// turn on RA0 analog
	ANSELAbits.ANSA1 = 1;	// turn on RA1 analog

    // Sets bits VCFG1 and VCFG0 in ADCON1 so the ADC voltage reference is VSS to VDD
    ADCON1 = 0;

    // The ADC clock must as short as possible but still greater than the
    // minimum TAD time, datasheet parameter 130. At the time this lesson was
    // written TAD minimum for the PIC18F24K22 is 0.7us.
    // At 32MHz clock, selecting ADCS = FOSC/32 = 1000000Hz. One clock period
    // 1 / 1000000Hz = 1us, which greater than minimum required 0.7us.
    // So ADCON2 bits ADCS2-0 = 010
	//
	// The ACQT aquisition time should take into accound the internal aquisition
    // time TACQ of the ADC, datasheet paramter 130, and the settling time of
    // of the application circuit connected to the ADC pin.  Since the actual
    // settling time of the RC circuit with the demo board potentiometer is very
    // long but accuracy is not very important to this demo, we'll set ACQT2-0 to
    // 20TAD = 111
	//
    // ADFM = 0 so we can easily read the 8 Most Significant bits from the ADRESH
    // Special Function Register
    ADCON2 = 0b00111010;

    // Select channel 0 (AN0) to read the potentiometer voltage and turn on ADC
    ADCON0 = 0b00000001;
}

// Conversion
unsigned char ADC_Convert(void)
{ // start an ADC conversion and return the 8 most-significant bits of the result
    ADCON0bits.GO_DONE = high;				// start conversion
    while (ADCON0bits.GO_DONE == high);		// wait for it to complete
    return(ADRESH);							// return high byte of result
}

// Calcul d'une valeur moyenne
unsigned char v_ad(unsigned char x)
{
    unsigned char i;
    unsigned char vad[4];
    unsigned int var0 = 0;

    in_anx(x);
    for (i = 0;i < 4;i++) vad[i] = ADC_Convert(), var0 += vad[i];
    return(var0 / 20);
}
