/**********************************************************************
*  Name    : Fonction gradateur                                       *
*  Author  : Nunes Dos Anjos Carlos                                   *
*  Notice  : Copyright (c) 2005 Nunes                                 *
*          : All Rights Reserved                                      *
*  Date    : 20/02/2013                                               *
*  Version : 1.0                                                      *
*  Notes   : Grad utilisant les interruptions du Timer 2              *
*          :                                                          *
**********************************************************************/

// Rappel pour sortir au milieu d'un programme d'une fonction sans utiliser
// les instructions "if" "else if" "else" mettre l'instruction "return;" sans argument
// pour une fonction sans retour de valeur ou mettre "return(..);" pour une fonction avec un
// retour de valeur.


/** Largeur avant allumage ******************************************/
void it_tmr2_grad(unsigned char x)
{
    static unsigned char i = 0;

    if (!flagsgrad.front3 && in_synchro)
    {
        flagsgrad.front1 = low, flagsgrad.front2 = low;
        flagsgrad.front3 = high, i = 0;
    }
    else if (i >= 50) flagsgrad.front3 = low;

    if ((x & 0b00000001) == out1_grad)
    {
        if (i < val0_largeur_grad) out1_grad_off();
        else if (!flagsgrad.front1) out1_grad_on(), flagsgrad.front1 = high;
        else if (flagsgrad.front1) out1_grad_off();
    }
    else out1_grad_off();

    if ((x & 0b00000010) == out2_grad)
    {
        if (i < val1_largeur_grad) out2_grad_off();
        else if (!flagsgrad.front2) out2_grad_on(), flagsgrad.front2 = high;
        else if (flagsgrad.front2) out2_grad_off();
    }
    else out2_grad_off();

    i++;
}
