/******************************************************************************
*  Name    : Gradateur Nunes                                                  *
*  Author  : Nunes Dos Anjos Carlos                                           *
*  Notice  : Copyright (c) 2005 Nunes                                         *
*          : All Rights Reserved                                              *
*  Date    : 20/02/2013                                                       *
*  Version : 1.0                                                              *
*  Notes   : Dclarations et affectations pour le programme principal         *
*          : gradateur Nunes                                                  *
*                                                                             *
******************************************************************************/

#ifndef __PROGGRADATEUR_H
#define __PROGGRADATEUR_H
//#include "p18cxxx.h"


/** D E C L A R A T I O N S  V A R I A B L E S *******************************/
#pragma idata
unsigned char chemin = 0;
unsigned char exitloop = 0;
unsigned char etape_couloir = 0;
unsigned char etape_entree = 0;
unsigned char memo0_val_puissance = 8;
unsigned char memo1_val_puissance = 8;

// drapeaux
union {
	unsigned char val;
	struct {
		unsigned front0:1;  // front pour etape 3 mipuissance couloir
		unsigned front1:1;  // front pour etape 3 mipuissance entre
		unsigned front2:1;  // front pour verrouiller entre veille
		unsigned front3:1;  // front pour led_ok
		unsigned front4:1;  // front pour verrouiller bp couloir
		unsigned front5:1;  // front pour verrouiler bp entree
		unsigned veille:1;  // autoriser
		unsigned bit7:1;    // libre
	};
}indic0bits = 0;


#pragma udata
/** Variables utilises  usage gnral ******************************/
unsigned char b0;	// b0 usage courant
unsigned char b1;	// b1 usage courant, drapeaux

/** Variables utilises **********************************************/
unsigned char temps1h_0;
unsigned char temps1h_1;
unsigned char temps1h_2;
unsigned char val_duree_couloir;
unsigned char val_duree_entree;
unsigned char valid;
unsigned char val_puissance_entree;


/** D E F I N I T I O N S ****************************************************/
#define high 1
#define low  0
#define off 0

#define clrwdt() _asm clrwdt _endasm
#define nop() _asm nop _endasm

#define test PORTCbits.RC7
#define in_couloir PORTBbits.RB0
#define in_entree PORTBbits.RB1
#define in_memo PORTBbits.RB3
#define in_select PORTBbits.RB4
#define in_veille PORTBbits.RB5
#define in6  PORTBbits.RB6
#define in7  PORTBbits.RB7

#define couloir 0b00000001
#define entree 0b00000010

#define debut 0
#define cycle 1

#define val_bp_t 10
#define val_demar_progressif 25	// valeur dmarrage progressif en ms
#define val_arret_degressif 240 // valeur arrt dgressif en ms
#define val_puissancemax 8		// valeur de largeur  pleine puissance en *100us afin que le triac puisse s'ammorcer
#define val_mipuissance 56		// valeur pour une puissance rduite
#define val_puissancemini1 66		// valeur pour une puissance rduite
#define val_puissancemini2 76		// valeur pour une puissance rduite
#define val_puissancemini 86	// valeur de largeur pour le dpart servant au dmarrage progressif en *100us
#define val_duree_puissancemax 6	// valeur de la duree de la puissance maxi en mn

#define grad_couloir_on() valid |= 0b00000001
#define grad_entree_on() valid |= 0b00000010
#define grad_couloir_off() valid &= 0b11111110
#define grad_entree_off() valid &= 0b11111101
#define grad_off() valid = 0

#define in_anx(x) ADCON0 |= ((x << 2) & 0b00000100)
#define adc_off() ADCON0 = 0


/** MACROS **********************************************************/
#define led_couloir_on() PORTCbits.RC2 = low
#define led_entree_on() PORTCbits.RC3 = low
#define led_couloir_off() PORTCbits.RC2 = high
#define led_entree_off() PORTCbits.RC3 = high

#define led_ok_on() PORTCbits.RC6 = low
#define led_ok_off() PORTCbits.RC6 = high


/** E X T E R N S ************************************************************/
// declare variables accessible by other files.

/** P R O T O T Y P E S ******************************************************/
void InterruptServiceHigh(void);
void ADC_Init(void);
unsigned char ADC_Convert(void);
unsigned char v_ad(unsigned char x);

#endif
