#ifndef __TIMER2TIMEBASE_H
#define __TIMER2TIMEBASE_H
//#include "p18cxxx.h"


/** D E C L A R A T I O N S **************************************************/
/** Dclaration des variables pour le TMR2 ***************************/
#pragma idata
unsigned char compt0_tmr2 = 10;
unsigned char compt00_tmr2 = 100;
unsigned char compt1_tmr2 = 5;
unsigned char compt2_tmr2 = 2;
unsigned char compt3_tmr2 = 60;
	
#pragma udata
unsigned char temps1ms_0;
unsigned char temps1ms_1;
unsigned char temps1ms_2;
unsigned char temps100ms_0;
unsigned char temps100ms_1;
unsigned char temps100ms_2;
unsigned char temps500ms_0;
unsigned char temps500ms_1;
unsigned char temps500ms_2;
unsigned char temps1s_0;
unsigned char temps1s_1;
unsigned char temps1s_2;
unsigned char temps1mn_0;
unsigned char temps1mn_1;
unsigned char temps1mn_2;

// Temps
union {
    unsigned char bits_timer2;
    struct {
        unsigned b1ms:1;   // impu1sion 1ms, priode 2ms
        unsigned b100ms:1; // impulsion 100ms, priode 200ms
        unsigned b500ms:1; // impulsion 500ms, priode 1mn
        unsigned b1s:1;    // impulsion 1s, priode 2s
        unsigned b1mn:1;   // impulsion 1mn, priode 2mn
        unsigned bit5:1;  // libre
        unsigned bit6:1;  // libre
        unsigned bit7:1;  // libre
    };
}temps;


/** D E F I N I T I O N S ****************************************************/


/** Configuration Timer2 *********************************************/
#define compt0_val 10  // 10 passages dans tmr2 = 10*0,1ms = 1ms
#define compt00_val 100	// 100 passages dans tmr2 = 100*1ms = 100ms
#define compt1_val 5    // 5 passages dans tmr2 = 5*100ms = 500ms
#define compt2_val 2    // 2 passages dans tmr2 = 2*500ms = 1s
#define compt3_val 60   // 60 passages dans tmr2 = 60*1s = 60s

#define prval 79  // le tmr2 compte (79+1)*(10*1)*0,125s = 100us (0,1ms)
                  // valeur dbordement
#define init_timer2 0b01001100  // posd.  10, prd.  1 , timer ON
                                // registre de contrle


/** E X T E R N S ************************************************************/
// declare variables accessible by other files.


/** P R O T O T Y P E S ******************************************************/
void it_tmr2_timebase(void);

#endif
